#ifndef INC_ACTOR_H
#define INC_ACTOR_H

#include "object.h"
#include "event.h"
#include "fov.h"
#include "constants.h"

struct ActionReturn;

class Actor : public Object {
    int hp;

    protected:
	map_t fovmap;

	virtual bool tryMove(Coord delta, bool force=false);
	void dirtyFov(bool setExplored=false);
    
    public:
	bool flying;
	bool isFocus;
	bool recompute_fov;
	int fovDist;
	
	virtual ActionReturn interact() = 0;
	virtual bool inFOV(const Coord& c);
	Actor(Coord c, Glyph glyph, bool flying=false) :
		Object(c, glyph), flying(flying),
		isFocus(false), recompute_fov(true), fovDist(FOV_RAD)
	    { fovmap.cells = NULL; }
	virtual ~Actor() {}
};


#endif /* INC_ACTOR_H */
