#include <unistd.h>
#include <assert.h>

#include "anim.h"
#include "view.h"


#ifdef __MINGW32__
#include <windows.h>
#define usleep(s) Sleep(1000*s)
#endif

void Anim::draw() {
    for (iterator fr = begin(); fr != end(); fr++) {
	fr->draw();
	gameView.refreshView();
	usleep(int(.20e6)); // 0.20s
	if (fr->cleanAfter)
	    fr->clearUp();
    }
    gameView.drawDirty();
    clear();
}

void Anim::addToCurrentFrame(const FrameSquare& fs) {
    if (empty())
	push_back(AnimFrame());
    back().push_back(fs);
}

void AnimFrame::draw() {
    for (iterator sq = begin(); sq != end(); sq++) {
	gameView.drawAtPos(sq->glyph, sq->pos);
	gameView.setDirty(sq->pos);
    }
}
void AnimFrame::clearUp() {
    for (iterator sq = begin(); sq != end(); sq++)
	gameView.drawAtPos(gameView.getGlyph(sq->pos), sq->pos);
}

FrameSquare::FrameSquare(Coord pos) : pos(pos) {
    glyph = gameView.getGlyph(pos);
}
