#ifndef INC_BASICAI_H
#define INC_BASICAI_H

#include "actor.h"
#include "object.h"
#include "event.h"
#include "fov.h"
#include "crittertype.h"
#include "random.h"
#include "constants.h"

struct ActionReturn;

class BasicAI : public Actor {
    private:
	int stunned;
	int noInterruptGoal;
	Coord goal;

	bool offturn;

	bool tryHit(Coord dir);
    public:
	bool isThreat() const { return (!stunned); }
	const CritterType* ctp;
	ActionReturn interact();
	void hit(int damage=1, const char* message="");
	const char* describe() const;
	bool isStatic() const;
	Glyph getGlyph() const;
	BasicAI(const CritterType* ctp, Coord c) :
	    Actor(c, ctp->glyph, ctp->flying),
	    stunned(0), noInterruptGoal(0),
	    goal(c), offturn(ctp->slow && rani(2)),
	    ctp(ctp) {}
	Object* clone() { return new BasicAI(*this); }
};

#endif /* INC_BASICAI_H */
