#include <assert.h>

#include "coord.h"

Coord orthDirsTmp[] =  { Coord(1,0), Coord(0,-1), Coord(-1,0), Coord(0,1) };
vector<Coord> orthDirs(orthDirsTmp, orthDirsTmp + sizeof(orthDirsTmp) / sizeof(Coord));
Coord dirsTmp[] =  { Coord(1,0), Coord(1,-1), Coord(0,-1), Coord(-1,-1),
    Coord(-1,0), Coord(-1,1), Coord(0,1), Coord(1,1) };
vector<Coord> dirs(dirsTmp, dirsTmp + sizeof(dirsTmp) / sizeof(Coord));

int dirIndex(const Coord& dir) {
    for (int i=0;i<8;i++)
	if (dirs[i] == dir)
	    return i;
    assert(false);
    return 0;
}

Coord orthDirTowards(const Coord& c) {
    if(c.x == 0 && c.y == 0)
	return Coord(0,0);
    const bool a = (c.x > c.y);
    const bool b = (c.x > -c.y);
    return Coord( a&&b ? 1 : ( a||b ? 0 : -1 ), !a&&b ? 1 : ( a||!b ? 0 : -1 ) );
}

Coord dirTowards(const Coord& coord) {
    if(coord.x == 0 && coord.y == 0)
	return Coord(0,0);
    const int a = (2*coord.x - coord.y);
    const int b = (2*coord.x - -coord.y);
    const int c = (2*coord.y - coord.x);
    const int d = (2*coord.y - -coord.x);
    return Coord( a>=0&&b>=0 ? 1 : ( a<=0&&b<=0 ? -1 : 0),
		c>=0&&d>=0 ? 1 : ( c<=0&&d<=0 ? -1 : 0));
}

Coord Coord::rotated(int rot) const {
    int xt=x, yt=y;
    rot %= 4;
    if (rot < 0) rot += 4;
    while (rot > 0) {
	const int ytt=yt;
	yt=-xt;
	xt=ytt;
	rot--;
    }
    return Coord(xt,yt);
}
