#include <stdio.h>
#include <list>
using namespace std;

#include "event.h"
#include "view.h"
#include "clock.h"
#include "actor.h"

void EventQueue::add(Event* event) {
    EventQueue::iterator i;
    for( i = begin(); i != end(); i++ )
	if (*event < *(*i))
	    break;
    insert(i, event);
}

void EventQueue::processNext() {
    EventQueue::iterator i = begin();
    if( i != end() ) {
	gameClock.time = (*i)->time;
	ActionReturn ar = (*i)->execute();
	processActionReturn( ar );
	delete *i;
	erase(i);
    }
}

void EventQueue::processActionReturn(ActionReturn ar) {
    for( list<Event*>::iterator ei = ar.events.begin(); ei != ar.events.end(); ei++ )
	add(*ei);
}

ActionReturn InteractEvent::execute() {
    return actor->interact();
}
