#include <curses.h>

#include "glyph.h"
#include "coord.h"

int attrOfCol(int col, bool reverse) {
    int attr;
    switch (col) {
	case BLACK : attr = COLOR_PAIR(COLOR_BLACK); break;
	case GREY : attr = COLOR_PAIR(COLOR_WHITE); break;
	case RED : attr = COLOR_PAIR(COLOR_RED); break;
	case GREEN : attr = COLOR_PAIR(COLOR_GREEN); break;
	case BROWN : attr = COLOR_PAIR(COLOR_YELLOW); break;
	case BLUE : attr = COLOR_PAIR(COLOR_BLUE); break;
	case MAGENTA : attr = COLOR_PAIR(COLOR_MAGENTA); break;
	case CYAN : attr = COLOR_PAIR(COLOR_CYAN); break;

	case DARKGREY: attr = COLOR_PAIR(63) | A_BOLD; break;
	case WHITE: attr = COLOR_PAIR(COLOR_WHITE) | A_BOLD; break;
	case B_RED : attr = COLOR_PAIR(COLOR_RED) | A_BOLD; break;
	case B_GREEN : attr = COLOR_PAIR(COLOR_GREEN) | A_BOLD; break;
	case YELLOW : attr = COLOR_PAIR(COLOR_YELLOW) | A_BOLD; break;
	case B_BLUE : attr = COLOR_PAIR(COLOR_BLUE) | A_BOLD; break;
	case B_MAGENTA : attr = COLOR_PAIR(COLOR_MAGENTA) | A_BOLD; break;
	case B_CYAN : attr = COLOR_PAIR(COLOR_CYAN) | A_BOLD; break;

	default: attr = 0;
    }
    if (reverse)
	attr |= A_REVERSE;
    return attr;
}

void drawGlyph(const Coord& c, Glyph g) {
    int attr = attrOfCol(g.col, g.reverse);
    attrset(attr);
    mvaddch( c.y, c.x, g.ch );
}
