#ifndef INC_MESSAGES_H
#define INC_MESSAGES_H

#include <cstdarg>
#include <string>
#include <vector>
using namespace std;

#include "glyph.h"

struct Message {
    string s;
    int attr;
    Message(const string& s, int col=GREY) : s(s), attr(attrOfCol(col)) {}
    Message(const char *format, va_list argp);
    Message(int col, const char *format, va_list argp);
};

class Messages {
    int line;
    int w;
    int h;
    bool newMessage, oldMessage;

    public:
	vector<Message> log;

	void draw();
	void redraw();
	void clearBox();
	void add(const Message& message);
	void add(const string& s, int col=GREY) {
	    add(Message(s,col)); }
	void addf(const char *format,...) {
	    va_list argp;
	    va_start(argp, format);
	    add(Message(format, argp));
	    va_end(argp); }
	void addf(int col, const char *format,...) {
	    va_list argp;
	    va_start(argp, format);
	    add(Message(col, format, argp));
	    va_end(argp); }

	void setGeom(int i_line, int i_w, int i_h) {
	    line=i_line; w=i_w; h=i_h; draw(); }
	Messages() : newMessage(false), oldMessage(false) {}
};

extern Messages logroll;

#endif /* INC_MESSAGES_H */
