#include <assert.h>

#include "object.h"
#include "view.h"
#include "cave.h"

void Object::move(Coord delta) {
    gameView.setDirty(pos);
    cave.objectmap.moveObject(this, pos+delta);
    gameView.setDirty(pos);
}

bool isObstruction(const Object& o) {
    return (!o.collectable());
}
bool isStaticObject(const Object& o) {
    return o.isStatic();
}
bool isStaticObstruction(const Object& o) {
    return (isObstruction(o) && isStaticObject(o));
}

Objects ObjectMap::objectsInCell(Coord c) {
    Objects ret;
    for (iterator i = lower_bound(c); i != upper_bound(c); i++)
	ret.insert(i->second);
    return ret;
}

void ObjectMap::erase(Object* o) {
    const Coord c = o->getPos();
    for (iterator i = lower_bound(c); i != upper_bound(c); i++)
	if (i->second == o) {
	    multimap<Coord,Object*>::erase(i);
	    break;
	}
}

void ObjectMap::moveObject(Object* o, Coord to) {
    erase(o);
    o->setPos(to);
    insert(o);
}
