#include "tile.h"
#include "glyph.h"

TileDef tileDefOfTile(Tile tile) {
    switch (tile) {
	case TILE_WALL : return TileDef( Glyph('#'), false, false );
	case TILE_FLOOR1 : return TileDef( Glyph('.', BROWN), true, true );
	case TILE_FLOOR2 : return TileDef( Glyph('.', GREY), true, true );
	case TILE_FLOOR3 : return TileDef( Glyph('.', RED), true, true );
	case TILE_FLOOR4 : return TileDef( Glyph('.', MAGENTA), true, true );
	case TILE_SURFACE : return TileDef( Glyph('.', YELLOW), false, true );
	case TILE_CAVE_ENTRANCE : return TileDef( Glyph('.', YELLOW), true, true );
	case TILE_EXIT : return TileDef( Glyph('<', WHITE), false, true,
				 "A tight twisting passage leads back to the surface." );
	case TILE_LAVA : return TileDef( Glyph('~', B_RED), false, true,
				 "A bubbling pool of lava." );
	case TILE_HIGH : return TileDef( Glyph('|', WHITE), true, true,
				 "The top of a rocky ridge, too steep for the probe to ascend.", 1 );
	case TILE_LOW : return TileDef( Glyph('_', WHITE), true, true,
				"The base of a rocky ridge. A fall down to here would damage the probe.", -1 );
	case TILE_NULL : return TileDef( Glyph(' '), false, false );
	default : return TileDef( Glyph('?'), false, false, "BUG!!!" );
    }
}

bool floorTile(Tile t) {
    return (t >= TILE_FLOOR1 && t < TILE_FLOOR_END);
}
